﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;
using System.Diagnostics;
using System.Collections;

namespace LearningPlugins
{
    public partial class MainForm : Form
    {
        List<PluginSystem.iPlugin> List;
        public MainForm()
        {
            InitializeComponent();
        }

        void HostCommunicator_ChangeTextBox(string msg)
        {
            textBox1.Text = msg;
        }

        public List<T> GetPlugins<T>(string folder)
        {
            string[] files = Directory.GetFiles(folder, "*.dll");
            List<T> tList = new List<T>();

            Debug.Assert(typeof(T).IsInterface);

            foreach (string file in files)
            {
                try
                {
                    Assembly assembly = Assembly.LoadFile(file);

                    foreach (Type type in assembly.GetTypes())
                    {
                        if (!type.IsClass || type.IsNotPublic) continue;
                        Type[] interfaces = type.GetInterfaces();

                        if (((IList)interfaces).Contains(typeof(T)))
                        {
                            object obj = Activator.CreateInstance(type);
                            T t = (T)obj;
                            tList.Add(t);
                        }
                    }
                }
                catch (Exception ex)
                {
                    //LogError(ex);
                }
            }
            return tList;
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            PluginSystem.HostCommunicator.ChangeTextBox += new PluginSystem.HostCommunicator.ChangeTextBoxEventHandler(HostCommunicator_ChangeTextBox);

            string exeName = Application.ExecutablePath;

            string folder = Path.Combine(Path.GetDirectoryName(exeName), "Plugins");

            List = GetPlugins<PluginSystem.iPlugin>(folder);

            listBox1.Items.Clear();

            foreach (PluginSystem.iPlugin plug in List)
            {

                string name = plug.PluginName;

                string desc = plug.PluginDescription;

                string author = plug.PluginAuthor;

                string str = string.Format("{0}, {1}, {2}",

                name, desc, author);

                listBox1.Items.Add(str);

            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            foreach (PluginSystem.iPlugin plug in List)
            {
                plug.Init();
            }
        }
    }
}
